<?php
/* 
    ALÔ PRA QUEM DÁ MANUTENÇÃO AQUI
    EU TIREI TODOS OS IDATIVOS DAQUI.

    Esse método deve dar pau -> findTabelasPreco
    ~ Thiago
    
*/
namespace Teknisa\MAN\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class TabelaPrecoRepository {

    protected  $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function getMaxId() {
        $query = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_MAXCDTABEPREC);
        $query->execute();
        return $query->fetchAll();
    }

    public function getCdfilial($nrorg) {
        $params = array(
            "NRORG" => $nrorg
       	); 
        $query = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_CDFILIAL,$params);
        $query->execute(array('NRORG' => $nrorg));
        $resultTabprec = $query->fetchAll();
        if(empty($resultTabprec)){
            $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_MAXCDFILIAL,$params);
            $stmt->execute(array('NRORG' => $nrorg));
            $resultCdfilial = $stmt->fetchAll();
            return $resultCdfilial[0]['CDFILIAL'];
        } else if (!empty($resultTabprec)){
            return $resultTabprec[0]['CDFILIAL'];
        }
    }

    public function findTabelasPreco($filter){
        if($filter[2]['value'] != ""){
          if ($filter[6]['value'] == "" && $filter[7]['value'] == ""){
            if ($filter[3]['value'] == ""){
              $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_TABEPREC);
              $stmt->execute(array('P_NRORG' => $filter[0]['value'],
                                   'CDFILIAL' => $filter[1]['value'],
                                   'CDTABEPREC' => $filter[3]['value'],
                                   'NMTABEPREC' => $filter[4]['value']));
              return $stmt->fetchAll();
            } else {
              $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_TABEPREC_BY_CDLOJA);
              $stmt->execute(array('P_NRORG' => $filter[0]['value'],
                                   'CDFILIAL' => $filter[1]['value'],
                                   'CDLOJA' => $filter[2]['value'],
                                   'CDTABEPREC' => $filter[3]['value'],
                                   'NMTABEPREC' => $filter[4]['value']));
              return $stmt->fetchAll();
            }
          } else {
            if ($filter[3]['value'] == ""){
              $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_TABEPREC_ORDER_CDTABEPREC);
              $stmt->execute(array('P_NRORG' => $filter[0]['value'],
                                 'CDFILIAL' => $filter[1]['value'],
                                 'CDTABEPREC' => $filter[3]['value'],
                                 'NMTABEPREC' => $filter[4]['value'],
                                  'DTINI' => $filter[5]['value'],
                                'DTFIM' => $filter[6]['value']));
              return $stmt->fetchAll();
            } else {
              $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_TABEPREC_BY_DATES);
              $stmt->execute(array('P_NRORG' => $filter[0]['value'],
                                   'CDFILIAL' => $filter[1]['value'],
                                   'CDLOJA' => $filter[2]['value'],
                                   'CDTABEPREC' => $filter[3]['value'],
                                   'NMTABEPREC' => $filter[4]['value'],
                                  'DTINI' => $filter[5]['value'],
                                'DTFIM' => $filter[6]['value']));
              return $stmt->fetchAll();
            }
          }
        } else {
          $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_ORGANIZATION_TABEPREC);
          $stmt->execute(array('P_NRORG' => $filter[0]['value'],
                                'CDTABEPREC' => $filter[3]['value'],
                                'NMTABEPREC' => $filter[4]['value'],
                                'DTINI' => $filter[5]['value'],
                                'DTFIM' => $filter[6]['value']
                        ));
          return $stmt->fetchAll();
        }
    }

    public function validaCodigoTabelaPreco($cdfilial, $cdtabeprec, $nrorg) {
      $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_CDTABEPREC_TABEPREC);
        $stmt->execute(array('CDFILIAL' => $cdfilial,
                             'CDTABEPREC' => $cdtabeprec,
                             'NRORG'     => $nrorg));
        $idRow = $stmt->fetchAll();
        foreach ($idRow as $row) {
            if($row['CDTABEPREC'] == $cdtabeprec) {
                return true;
            }
        }
        return false;
    }
}